// importieren von Bibliotheken, etc
import ch.aplu.jgamegrid.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class Break extends Actor //Break als Actor
{
  private int Ticker = 0; //Laufvariable für Sekunden
  private int Sekunden; //Zeit für die Pause
  private int v = 41; //Geschwindigkeit zum Erscheinen / Verschwinden
  private int aktion = -1; //-1: deaktiviert, 0: Zählt die Sekunden runter, 1: Erscheinen, 2: Verschwinden
  private boolean fertig = true; //Abfrage ob das Erscheinen oder Verschwinden schon abgeschlossen ist

  public Break(String Folder) //Konstruktor erwartet String des Bilds
  {
    super(Folder); //Actor Konstruktor wird aufgerufen und Pfad des Bildes wird übergeben
  }

  public void prepare_Sound() //Funktion um eine kurze Verzögerung des Sounds zu vermeiden
  {
    gameGrid.playSound(this, GGSound.DUMMY); //spielt eine leere Sounddatei namens DUMMY ab
  }

  public void Tick() //Funktion um die Sekunden herunter zu zählen
  {
    if (fertig == true) //es soll nur zur Erhöhung des Tickers kommen, wenn das Erscheinen oder Verschwinden abgeschlossen ist
    {
      Ticker++; //Erhöhen des Tickers
      if (Ticker == 100) //nach 100 Ticks ist eine Sekunde vorbei
      {
        Sekunden--; //Erniedrigung der Sekunden
        Ticker = 0; //Ticker wird für neue Sekunde auf 0 gesetzt
        if (Sekunden != 0) //nur wenn es mehr als eine Sekunde ist...
        {
          gameGrid.playSound(this, "wav/beep.wav"); //...wird beep abgespielt
        }
      }
    }
  }

  public void set_Sekunden(int t) //Funktion zum Setzen der Sekunden (Zieht eine Aktivierung des Actors mit sich, wie auch das Setzen der Aktion
  {
    Sekunden = t; //Sekunden werden festgelegt durch erwarteten Parameter t
    show(); //wird sichtbar gemacht
    set_Aktion(1); //Erscheinungsvorgang wird aktiviert
  }

  public int get_Sekunden() //Funktion zum abrufen der Sekunden
  {
    return (Sekunden); //die Sekunden werden zurückgegeben
  }

  public void set_Aktion(int set) //Funktion zum Setzen der Aktion
  {
    aktion = set; //aktion wird durch erwarteten Parameter set festgelegt
    if (aktion == 2) //falls die neue aktion Verschwinden ist..
    {
      gameGrid.playSound(this, "wav/Breaker2.wav");//...wird der Verschwinden-Ton abgespielt
      v = 0; //...Die Geschwindigkeit auf 0 gesetzt
      setX(400);//..x auf 400 gesetzt
      fertig = false;//...fertig auf false gesetzt, damit der Ticker nicht losläuft
    }
    else if (aktion == 1) //falls die neue aktion Erscheinen ist..
    {
      gameGrid.playSound(this, "wav/Breaker1.wav");//...wird der Verschwinden-Ton abgespielt
      setX(-400);//..x auf -400 gesetzt
      v = 41;//...Die Geschwindigkeit auf 41 gesetzt
      fertig = false;//...fertig auf false gesetzt, damit der Ticker nicht losläuft
    }
  }

  public void Erscheinen() //Erscheinenfunktion(periodisch)
  {
    v = v - 1; //die Geschwindigkeit wird um 1 veringert
    if (getX() > 400) //fals x frößer als 399 ist, dann ist die Mittedes Bildschirms erreicht
    {
      setX(400);//x wird auf 400 gesetzt
      set_Aktion(0);//der Ticker soll loslaufen
      fertig = true;//fertig wird auf true gesetzt
    }
    else
    {
      setX(getX() + v); //ansonsten wird v zu x dazugezählt
    }
  }

  public void Verschwinden() //funktion zum Verschwinden
  {
    v = v + 1; //Geschwindigkeit wird um 1 erhöht
    setX(getX() + v); //und zu x dazugezählt
    if (getX() >= 1200) //falss x >1999 ist, dann ist der Breaker wieder außerhalb des Bildschirms und...
    {
      hide(); //...verschwindet
      setX(-400);//...wird wieder auf die linke Seite gesetzt
      set_Aktion(-1);//...soll wieder untätig sein
      fertig = true;//...ist fertig
    }
  }

  public int get_Aktion()//Funktion zum Erhalten der aktion
  {
    return (aktion);//gibt aktuelle Aktion zurück
  }

}