// importieren von Bibliotheken, etc
// beep.wav aus Blitz Basic/help/samples/sounds
// Erscheinen und Verschwinden des Breakers aus http://www.youtube.com/watch?v=ivAZXsf6_zs&feature=results_video&playnext=1&list=PL5218845D56387DAE
import ch.aplu.jgamegrid.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.applet.*;
import java.net.*;

public class Spielfeld extends GameGrid //Spielfeld als Gamegrid
{
  Spieler Spieler1 = new Spieler(100); //Spieler1 der Klasse Spieler wird erzeugt
  Ball Ball1 = new Ball();//Ball1 der Klasse Ball wird erzeugt
  Break BreakerGetReady;//GetReady der Klasse Break wird erzeugt
  Break BreakerGameOver;//GameOver der Klasse Break wird erzeugt
  Break BreakerBreakout;//Breakout der Klasse Break wird erzeugt
  public GGBackground bg;//Hintergrund wird erzeugt
  public int GFXBreite = 800;
  public int GFXHoehe = 600;
  public int SpielfeldBreite = 600;
  public int SpielfeldHoehe = 600;
  public int SchlaegerBreite = 100;
  public int SchlaegerHoehe = 23;
  public int MaxBlockAnzahl = 100;
  public int BlockBreite = 50;
  public int BlockHoehe = 23;
  public int BallRadius = 8;
  public int Ball_Start_X = 300;
  public int Ball_Start_Y = 500;
  public int SpielerX = 300;
  public int SpielerY = 550;
  public int BlockAnzahl;
  Block[] Bloecke = new Block[MaxBlockAnzahl]; //Array mit Block-Objekten wird erzeugt
  public int Rand = 10;
  public int Level = 0;
  public int MaxLevel = 10;
  String[] LevelMap = new String[8]; //Levelarray mit Strings wird erzeugt

  public Spielfeld() //Konstruktor
  {
    super(800, 600, 1, null, "sprites/Hintergrund4.png", false); //Erstellen des Grafikfensters
    setSimulationPeriod(10); //Periode zum Aufrufen von Act festlegen in ms
    addActor(Spieler1, new Location(SpielerX, SpielerY), Location.WEST); //Spieler1 wird dazugefügt
    addActor(Ball1, new Location(Ball_Start_X, Ball_Start_Y), Location.SOUTH); //Ball1 wird dazugefügt
    Ball1.prepare_BallX(); //BallX und X weden abgeglichen
    Ball1.prepare_BallY();//BallY und Y weden abgeglichen
    BreakerGetReady = new Break("sprites/Break3.png"); //GetReady wird definiert
    addActor(BreakerGetReady, new Location(-400, 295), Location.SOUTH);//GetReady wird dazugefügt
    BreakerGameOver = new Break("sprites/BreakGameOver.png");//GameOver wird definiert
    addActor(BreakerGameOver, new Location(-400, 295), Location.SOUTH); //GameOver wird dazugefügt
    BreakerGetReady.prepare_Sound(); //Dummy sound wird abgespielt
    BreakerBreakout = new Break("sprites/BreakBreakout.png"); //Breakout wird definiert
    addActor(BreakerBreakout, new Location(-400, 295), Location.SOUTH); //Breakout wird dazugefügt
    BreakerBreakout.set_Sekunden(1); //Breakout wird aktiviert
    bg = getBg(); //Hintergrund abgerufen
    Font Schrift18 = new Font("Impact", 0, 18); //Schrift wird geladen
    bg.setFont(Schrift18); //Schrift wird gesetzt
    show(); //Fenster wird angezeigt
    doRun(); //Periodenaftes Aufrufen von Act startet
  }

  public void LoadLevel() //Laden von Level
  {

    for (int i = 0; i < MaxBlockAnzahl; i++) //Löschen aller bestehenden Bloecke
    {
      if (Bloecke[i] != null) //wenn der Block existiert...
      {
        Bloecke[i].removeSelf(); //...wird er entfert
        Bloecke[i] = null; //.. und die Referenz gelöscht
      }
    }

    BlockAnzahl = 0; //Anzahl wird wieder auf 0 gesetzt
    int x;
    int y;
    int EinheitX = 70; //Abstand X
    int EinheitY = 50;//Abstand Y
    String Typ; //Blocktyp
    if (Level == 1) //wenn das aktuelle Level 1 ist, dann...
    {
      LevelMap[0] = "        "; //..sieht diese Zeile so aus (die Zahlen sind die Typen der Bloecke)
      LevelMap[1] = "        ";
      LevelMap[2] = "        ";
      LevelMap[3] = "000 000 ";
      LevelMap[4] = "        ";
      LevelMap[5] = "000 000 ";
      LevelMap[6] = "        ";
      LevelMap[7] = "        ";
    }

    if (Level == 2)
    {
      LevelMap[0] = "        ";
      LevelMap[1] = "00000000";
      LevelMap[2] = "        ";
      LevelMap[3] = "  0110  ";
      LevelMap[4] = "  0110  ";
      LevelMap[5] = "        ";
      LevelMap[6] = "00000000";
      LevelMap[7] = "        ";
    }

    if (Level == 3)
    {
      LevelMap[0] = " 0    0 ";
      LevelMap[1] = "  0  0  ";
      LevelMap[2] = "   11   ";
      LevelMap[3] = "  1  1  ";
      LevelMap[4] = "   11   ";
      LevelMap[5] = "  0  0  ";
      LevelMap[6] = " 0    0 ";
      LevelMap[7] = "0      0";
    }

    if (Level == 4)
    {
      LevelMap[0] = " 1    1 ";
      LevelMap[1] = "202  202";
      LevelMap[2] = "        ";
      LevelMap[3] = "   11   ";
      LevelMap[4] = "  0220  ";
      LevelMap[5] = " 00  00 ";
      LevelMap[6] = "000  000";
      LevelMap[7] = "   00   ";
    }

    if (Level == 5)
    {
      LevelMap[0] = "   00   ";
      LevelMap[1] = "  1111  ";
      LevelMap[2] = " 2    2 ";
      LevelMap[3] = "2      2";
      LevelMap[4] = "333  333";
      LevelMap[5] = "2  22  2";
      LevelMap[6] = "1      1";
      LevelMap[7] = "0      0";
    }

    if (Level == 6)
    {
      LevelMap[0] = "3      3";
      LevelMap[1] = " 3    3 ";
      LevelMap[2] = "  2222  ";
      LevelMap[3] = "  4  4  ";
      LevelMap[4] = "  4  4  ";
      LevelMap[5] = "  2002  ";
      LevelMap[6] = " 3    3 ";
      LevelMap[7] = "3      3";
    }

    if (Level == 7)
    {
      LevelMap[0] = "10000001";
      LevelMap[1] = "0  11  0";
      LevelMap[2] = "0  11  0";
      LevelMap[3] = "04343430";
      LevelMap[4] = "0  00  0";
      LevelMap[5] = "02121210";
      LevelMap[6] = "0  12  0";
      LevelMap[7] = "10021001";
    }

    if (Level == 8)
    {
      LevelMap[0] = "22222222";
      LevelMap[1] = "2      2";
      LevelMap[2] = "2  11  2";
      LevelMap[3] = "2 1001 2";
      LevelMap[4] = "2 1001 2";
      LevelMap[5] = "2  11  2";
      LevelMap[6] = "2      2";
      LevelMap[7] = "23144132";
    }

    if (Level == 9)
    {
      LevelMap[0] = "1      1";
      LevelMap[1] = " 442234 ";
      LevelMap[2] = " 0 22 0 ";
      LevelMap[3] = " 03  30 ";
      LevelMap[4] = " 0 22 0 ";
      LevelMap[5] = " 03  30 ";
      LevelMap[6] = " 432234 ";
      LevelMap[7] = "1      1";
    }

    if (Level == 10)
    {
      LevelMap[0] = "1      1";
      LevelMap[1] = "04444440";
      LevelMap[2] = "1      1";
      LevelMap[3] = " 332233 ";
      LevelMap[4] = "1      1";
      LevelMap[5] = " 332233 ";
      LevelMap[6] = "1      1";
      LevelMap[7] = "04444440";
    }

    for (int i = 0; i < 8; i++) //für alle Reihen
    {
      for (int l = 0; l < 8; l++) //für alle Buchstaben innerhalb des Strings
      {
        Typ = "" + LevelMap[i].charAt(l); //Typ ist nun das Zeichen an der Stelle von l
        if (LevelMap[i].charAt(l) != ' ') //falls Typ nicht " " ist
        {
          Bloecke[BlockAnzahl] = new Block("sprites/Block" + Typ + ".png");//neuer Block wird erzeugt..
          addActor(Bloecke[BlockAnzahl], new Location(l * EinheitX + 55, i * EinheitY + 40), Location.SOUTH);//...und hinzugefügt
          BlockAnzahl++; //Anzahl wird erhöht
        }
      }
    }
    if (Level == 1)
    {
      setPaintOrder(GGBackground.class, Break.class, Block.class, Ball.class, Spieler.class);
    } //Malreihenfolge wird festgelegt
  }

  public void act() //periodenhafter Aufruf
  {
    //Eingaben  
    if (BreakerGetReady.get_Sekunden() <= 0 && BreakerGameOver.get_Sekunden() <= 0 && BreakerBreakout.get_Sekunden() <= 0) //falls nicht gerade eine Pause ist
    {
      if (isKeyPressed(KeyEvent.VK_RIGHT)) //falls rechts gedrückt ist
      {
        if (Spieler1.getX() < SpielfeldBreite - SchlaegerBreite / 2 - Rand) //und der Schläger im steuerbaren Bereich ist
        {
          Spieler1.setX(Spieler1.getX() + Spieler1.getVX()); //dann wird sein X um VX erhöht
        }
      }
      if (isKeyPressed(KeyEvent.VK_LEFT)) //falls links gedrückt ist
      {
        if (Spieler1.getX() > 0 + SchlaegerBreite / 2 + Rand)//und der Schläger im steuerbaren Bereich ist
        {
          Spieler1.setX(Spieler1.getX() - Spieler1.getVX());//dann wird sein X um VX erniedrigt
        }
      }

      if ((Ball1.getX() - BallRadius < Rand) || ((Ball1.getX() + BallRadius)) > SpielfeldBreite - Rand) //falls der Ball zu weit rechts oder links ist, dann...
      {
        Ball1.AbprallenX(); //prallt er in X Richtung ab
      }

      if ((Ball1.getY() - BallRadius < Rand))  //falls der Ball zu weit oben ist, dann...
      {
        Ball1.AbprallenY(0); //prallt er in Y Richtung ab
      }

      Ball1.moveX(); //Bewegung in X Richtung
      //Schläger
      if (RectsOverlap(Ball1.getX() - BallRadius, Ball1.getY() - BallRadius, BallRadius * 2, BallRadius * 2, Spieler1.getX() - SchlaegerBreite / 2, Spieler1.getY() - SchlaegerHoehe / 2, SchlaegerBreite, SchlaegerHoehe)) //falls der Ball nun den Schläger berührt, dann...
      {
        Ball1.AbprallenX(); //prallt er in X Richtung ab
      }
      //Steine
      for (int i = 0; i < MaxBlockAnzahl; i++) //für alle Bloecke
      {
        if (Bloecke[i] != null) //falls der Block nicht null ist
        {
          if (RectsOverlap(Ball1.getX() - BallRadius, Ball1.getY() - BallRadius, BallRadius * 2, BallRadius * 2, Bloecke[i].getX() - BlockBreite / 2, Bloecke[i].getY() - BlockHoehe / 2, BlockBreite, BlockHoehe))//falls der Ball nun den Block berührt, dann...
          {
            Ball1.AbprallenX();//prallt er in X Richtung ab
            Bloecke[i].hit(Ball1.get_Damage()); //Block verliert Leben
            if (Bloecke[i].get_Leben() <= 0) //wenn der Block weniger als 1 Leben hat, dann
            {
              Bloecke[i].removeSelf();//wird er entfernt
              Bloecke[i] = null;//wird die Referenz gelöscht
              playSound(this, "wav/blockbreak.wav");//wird break abgespielt
              BlockAnzahl--;//wird die Anzahl um 1 vermindert
              if (BlockAnzahl == 0) //falls es keine Blöcke mehr gibt
              {
                NextLevel();//wird das nächste Level geladen
              }
            }
            else //ansonsten
            {
              playSound(this, "wav/blockhit.wav");//wird nur der Hit sound abgespielt
            }
          }
        }
      }
      Ball1.moveY(); //nun wird der Ball in Y Richtung bewegt
      //Schläger
      if (RectsOverlap(Ball1.getX() - BallRadius, Ball1.getY() - BallRadius, BallRadius * 2, BallRadius * 2, Spieler1.getX() - SchlaegerBreite / 2, Spieler1.getY() - SchlaegerHoehe / 2, SchlaegerBreite, SchlaegerHoehe))//falls der Ball nun den Schläger berührt, dann...
      {
        Ball1.AbprallenY(Ball1.getX() - Spieler1.getX()); //dann prallt er in X Richtung ab
      }
      //Steine (Kommentare: siehe oben!)
      for (int i = 0; i < MaxBlockAnzahl; i++)
      {
        if (Bloecke[i] != null)
        {
          if (RectsOverlap(Ball1.getX() - BallRadius, Ball1.getY() - BallRadius, BallRadius * 2, BallRadius * 2, Bloecke[i].getX() - BlockBreite / 2, Bloecke[i].getY() - BlockHoehe / 2, BlockBreite, BlockHoehe))
          {
            Ball1.AbprallenY(0);
            Bloecke[i].hit(Ball1.get_Damage());
            if (Bloecke[i].get_Leben() <= 0)
            {
              Bloecke[i].removeSelf();
              Bloecke[i] = null;
              playSound(this, "wav/blockbreak.wav");
              BlockAnzahl--;
              if (BlockAnzahl == 0)
              {
                NextLevel();
              }
            }
            else
            {
              playSound(this, "wav/blockhit.wav");
            }
          }
        }
      }
    }

    if (BreakerGetReady.get_Aktion() != -1) //falls der Breaker aktiv ist
    {
      if (BreakerGetReady.get_Aktion() == 1) //falls er Erscheint
      {
        BreakerGetReady.Erscheinen(); //dann wird seine Funktion Erscheinen aufgerufen
      }
      else if (BreakerGetReady.get_Aktion() == 2)//falls er Verschwindet
      {
        BreakerGetReady.Verschwinden();//dann wird seine Funktion Verschwinden aufgerufen
      }
      else if (BreakerGetReady.get_Aktion() == 0)//falls er tickt
      {
        if (BreakerGetReady.get_Sekunden() > 0)//falls die Sekunden über 0 sind
        {
          BreakerGetReady.Tick(); //soll er ticken
        }
        if (BreakerGetReady.get_Sekunden() == 0) //falls die Sekunden 0 sind
        {
          BreakerGetReady.set_Aktion(2);//soll er wieder Verschwinden
        }
      }
    }

    if (BreakerBreakout.get_Aktion() != -1) //(Kommentar: Siehe oben!)
    {
      if (BreakerBreakout.get_Aktion() == 1)
      {
        BreakerBreakout.Erscheinen();
      }
      else if (BreakerBreakout.get_Aktion() == 2)
      {
        BreakerBreakout.Verschwinden();
      }
      else if (BreakerBreakout.get_Aktion() == 0)
      {
        if (BreakerBreakout.get_Sekunden() > 0)
        {
          BreakerBreakout.Tick();
        }
        if (BreakerBreakout.get_Sekunden() == 0) //falls die Sekunden 0 sind
        {
          BreakerBreakout.set_Aktion(2); //soll er wieder Verschinden
          NextLevel();//soll das nächste Leven geladen werden
        }
      }
    }

    if (BreakerGameOver.get_Aktion() != -1)
    {
      if (BreakerGameOver.get_Aktion() == 1)
      {
        BreakerGameOver.Erscheinen();
      }
      else if (BreakerGameOver.get_Aktion() == 2)
      {
        BreakerGameOver.Verschwinden();
      }
      else if (BreakerGameOver.get_Aktion() == 0)
      {
        if (BreakerGameOver.get_Sekunden() > 0)
        {
          BreakerGameOver.Tick();
        }
        if (BreakerGameOver.get_Sekunden() == 0)//falls die Sekunden 0 sind
        {
          BreakerGameOver.set_Aktion(2);//soll er wieder Verschinden
          BreakerGetReady.set_Sekunden(4);//soll GetReady erscheinen
        }
      }
    }

    if (((Ball1.getY() + BallRadius)) > SpielfeldHoehe - Rand) //falls der Ball unter GFXHoehe kommt
    {
      Spieler1.set_Leben(Spieler1.get_Leben() - 1); //bekommt der Spieler ein Leben abgezogen
      if (Spieler1.get_Leben() == 0)//falls die Leben 0 sind
      {
        Level = 0; //wird das Level auf 0 zurückgesetzt
        NextLevel(); //wird das nächste Level geladen
        BreakerGameOver.set_Sekunden(1);//soll GameOver erscheinen
      }
      else //ansonsten
      {
        BreakerGetReady.set_Sekunden(4); //soll GetReady erscheinen
        restorePlayer_Ball(); //Spieler und Ball zurückgesetzt werden
      }
    }
    setBgColor(java.awt.Color.black); //vorheriger Text wird gelöscht
    bg.setPaintColor(Color.orange); //Orange als Schriftfarbe
    bg.drawText("Level " + Level, new Point(620, 150));//Text
    bg.drawText("Verbleibende Steine " + BlockAnzahl, new Point(620, 180));//Text
    bg.drawText("Leben " + Spieler1.get_Leben(), new Point(620, 210));//Text
  }

  public void restorePlayer_Ball() //Zurücksetzen der Werte von Spieler und Ball
  {
    Ball1.setX(Ball_Start_X);//setzt X zurück
    Ball1.setY(Ball_Start_Y);//setzt Y zurück
    Ball1.prepare_BallX(); //gleicht X und BallX ab
    Ball1.prepare_BallY(); //gleicht Y und BallY ab
    Ball1.set_V((float)3); //setzt V auf 3
    Ball1.restoreVX(); //setzt VX zurück
    Ball1.changeVX();//gleicht VX Änderung aus für VY
    Spieler1.setX(SpielerX); //setzt Spieler X zurück 
    Spieler1.setY(SpielerY); //setzt Spieler Y zurück
  }

  public void NextLevel() //Laden des nächsten Levels
  {
    Spieler1.set_Leben(3); //setzt Leben auf 3
    BreakerGetReady.set_Sekunden(4);    //aktiviert GetReady
    restorePlayer_Ball(); //setzt Werte von Spieler und Ball zurück
    if (Level != MaxLevel) //falls die maximale nicht Levelanzahl erreicht ist
    {
      Level++; //soll das Level um 1 erhöht werden
      LoadLevel(); //dieses Level geladen werden
    }
    else if (Level == MaxLevel) //falls die maximale Levelanzahl erreicht ist
    {
      LoadLevel(); //Level 1 geladen werden
    }
  }

  public boolean RectsOverlap(int x1, int y1, int b1, int h1, int x2, int y2, int b2, int h2) //Überprüfen auf Überlappung
  {
    return (x1 + b1 > x2 && x1 < x2 + b2 && y1 + h1 > y2 && y1 < y2 + h2); //gibt true zurück, wenn alle Bedingungen wahr sind
  }

  public static void main(String[] args) //wird ganz zu Anfang automatisch aufgerufen
  {
    new Spielfeld(); //erzeugt neues Spielfeld
  }

}
